export const L2MigratorABI = [
  {
    inputs: [
      { internalType: 'address', name: '_l1Migrator', type: 'address' },
      {
        internalType: 'address',
        name: '_delegatorPoolImpl',
        type: 'address',
      },
      {
        internalType: 'address',
        name: '_bondingManagerAddr',
        type: 'address',
      },
      {
        internalType: 'address',
        name: '_ticketBrokerAddr',
        type: 'address',
      },
      {
        internalType: 'address',
        name: '_merkleSnapshotAddr',
        type: 'address',
      },
      { internalType: 'address', name: '_tokenAddr', type: 'address' },
    ],
    stateMutability: 'nonpayable',
    type: 'constructor',
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: true,
        internalType: 'address',
        name: 'l1Addr',
        type: 'address',
      },
      {
        indexed: false,
        internalType: 'address',
        name: 'delegatorPool',
        type: 'address',
      },
    ],
    name: 'DelegatorPoolCreated',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        components: [
          { internalType: 'address', name: 'l1Addr', type: 'address' },
          { internalType: 'address', name: 'l2Addr', type: 'address' },
          { internalType: 'uint256', name: 'stake', type: 'uint256' },
          {
            internalType: 'uint256',
            name: 'delegatedStake',
            type: 'uint256',
          },
          { internalType: 'uint256', name: 'fees', type: 'uint256' },
          { internalType: 'address', name: 'delegate', type: 'address' },
        ],
        indexed: false,
        internalType: 'struct IMigrator.MigrateDelegatorParams',
        name: 'params',
        type: 'tuple',
      },
    ],
    name: 'MigrateDelegatorFinalized',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        components: [
          { internalType: 'address', name: 'l1Addr', type: 'address' },
          { internalType: 'address', name: 'l2Addr', type: 'address' },
          { internalType: 'uint256', name: 'deposit', type: 'uint256' },
          { internalType: 'uint256', name: 'reserve', type: 'uint256' },
        ],
        indexed: false,
        internalType: 'struct IMigrator.MigrateSenderParams',
        name: 'params',
        type: 'tuple',
      },
    ],
    name: 'MigrateSenderFinalized',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        components: [
          { internalType: 'address', name: 'l1Addr', type: 'address' },
          { internalType: 'address', name: 'l2Addr', type: 'address' },
          { internalType: 'uint256', name: 'total', type: 'uint256' },
          {
            internalType: 'uint256[]',
            name: 'unbondingLockIds',
            type: 'uint256[]',
          },
          { internalType: 'address', name: 'delegate', type: 'address' },
        ],
        indexed: false,
        internalType: 'struct IMigrator.MigrateUnbondingLocksParams',
        name: 'params',
        type: 'tuple',
      },
    ],
    name: 'MigrateUnbondingLocksFinalized',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: true,
        internalType: 'bytes32',
        name: 'role',
        type: 'bytes32',
      },
      {
        indexed: true,
        internalType: 'bytes32',
        name: 'previousAdminRole',
        type: 'bytes32',
      },
      {
        indexed: true,
        internalType: 'bytes32',
        name: 'newAdminRole',
        type: 'bytes32',
      },
    ],
    name: 'RoleAdminChanged',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: true,
        internalType: 'bytes32',
        name: 'role',
        type: 'bytes32',
      },
      {
        indexed: true,
        internalType: 'address',
        name: 'account',
        type: 'address',
      },
      {
        indexed: true,
        internalType: 'address',
        name: 'sender',
        type: 'address',
      },
    ],
    name: 'RoleGranted',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: true,
        internalType: 'bytes32',
        name: 'role',
        type: 'bytes32',
      },
      {
        indexed: true,
        internalType: 'address',
        name: 'account',
        type: 'address',
      },
      {
        indexed: true,
        internalType: 'address',
        name: 'sender',
        type: 'address',
      },
    ],
    name: 'RoleRevoked',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: true,
        internalType: 'address',
        name: 'delegator',
        type: 'address',
      },
      {
        indexed: false,
        internalType: 'address',
        name: 'delegate',
        type: 'address',
      },
      {
        indexed: false,
        internalType: 'uint256',
        name: 'stake',
        type: 'uint256',
      },
      {
        indexed: false,
        internalType: 'uint256',
        name: 'fees',
        type: 'uint256',
      },
    ],
    name: 'StakeClaimed',
    type: 'event',
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: true,
        internalType: 'address',
        name: '_from',
        type: 'address',
      },
      {
        indexed: true,
        internalType: 'address',
        name: '_to',
        type: 'address',
      },
      {
        indexed: true,
        internalType: 'uint256',
        name: '_id',
        type: 'uint256',
      },
      {
        indexed: false,
        internalType: 'bytes',
        name: '_data',
        type: 'bytes',
      },
    ],
    name: 'TxToL1',
    type: 'event',
  },
  {
    inputs: [],
    name: 'DEFAULT_ADMIN_ROLE',
    outputs: [{ internalType: 'bytes32', name: '', type: 'bytes32' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [],
    name: 'GOVERNOR_ROLE',
    outputs: [{ internalType: 'bytes32', name: '', type: 'bytes32' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [],
    name: 'bondingManagerAddr',
    outputs: [{ internalType: 'address', name: '', type: 'address' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [
      { internalType: 'address', name: '_delegate', type: 'address' },
      { internalType: 'uint256', name: '_stake', type: 'uint256' },
      { internalType: 'uint256', name: '_fees', type: 'uint256' },
      { internalType: 'bytes32[]', name: '_proof', type: 'bytes32[]' },
      { internalType: 'address', name: '_newDelegate', type: 'address' },
    ],
    name: 'claimStake',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [],
    name: 'claimStakeEnabled',
    outputs: [{ internalType: 'bool', name: '', type: 'bool' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'address', name: '', type: 'address' }],
    name: 'claimedDelegatedStake',
    outputs: [{ internalType: 'uint256', name: '', type: 'uint256' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [],
    name: 'delegatorPoolImpl',
    outputs: [{ internalType: 'address', name: '', type: 'address' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'address', name: '', type: 'address' }],
    name: 'delegatorPools',
    outputs: [{ internalType: 'address', name: '', type: 'address' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [
      {
        components: [
          { internalType: 'address', name: 'l1Addr', type: 'address' },
          { internalType: 'address', name: 'l2Addr', type: 'address' },
          { internalType: 'uint256', name: 'stake', type: 'uint256' },
          {
            internalType: 'uint256',
            name: 'delegatedStake',
            type: 'uint256',
          },
          { internalType: 'uint256', name: 'fees', type: 'uint256' },
          { internalType: 'address', name: 'delegate', type: 'address' },
        ],
        internalType: 'struct IMigrator.MigrateDelegatorParams',
        name: '_params',
        type: 'tuple',
      },
    ],
    name: 'finalizeMigrateDelegator',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [
      {
        components: [
          { internalType: 'address', name: 'l1Addr', type: 'address' },
          { internalType: 'address', name: 'l2Addr', type: 'address' },
          { internalType: 'uint256', name: 'deposit', type: 'uint256' },
          { internalType: 'uint256', name: 'reserve', type: 'uint256' },
        ],
        internalType: 'struct IMigrator.MigrateSenderParams',
        name: '_params',
        type: 'tuple',
      },
    ],
    name: 'finalizeMigrateSender',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [
      {
        components: [
          { internalType: 'address', name: 'l1Addr', type: 'address' },
          { internalType: 'address', name: 'l2Addr', type: 'address' },
          { internalType: 'uint256', name: 'total', type: 'uint256' },
          {
            internalType: 'uint256[]',
            name: 'unbondingLockIds',
            type: 'uint256[]',
          },
          { internalType: 'address', name: 'delegate', type: 'address' },
        ],
        internalType: 'struct IMigrator.MigrateUnbondingLocksParams',
        name: '_params',
        type: 'tuple',
      },
    ],
    name: 'finalizeMigrateUnbondingLocks',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'bytes32', name: 'role', type: 'bytes32' }],
    name: 'getRoleAdmin',
    outputs: [{ internalType: 'bytes32', name: '', type: 'bytes32' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [
      { internalType: 'bytes32', name: 'role', type: 'bytes32' },
      { internalType: 'address', name: 'account', type: 'address' },
    ],
    name: 'grantRole',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [
      { internalType: 'bytes32', name: 'role', type: 'bytes32' },
      { internalType: 'address', name: 'account', type: 'address' },
    ],
    name: 'hasRole',
    outputs: [{ internalType: 'bool', name: '', type: 'bool' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [],
    name: 'l1Migrator',
    outputs: [{ internalType: 'address', name: '', type: 'address' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [],
    name: 'merkleSnapshotAddr',
    outputs: [{ internalType: 'address', name: '', type: 'address' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'address', name: '', type: 'address' }],
    name: 'migratedDelegators',
    outputs: [{ internalType: 'bool', name: '', type: 'bool' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'address', name: '', type: 'address' }],
    name: 'migratedSenders',
    outputs: [{ internalType: 'bool', name: '', type: 'bool' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [
      { internalType: 'address', name: '', type: 'address' },
      { internalType: 'uint256', name: '', type: 'uint256' },
    ],
    name: 'migratedUnbondingLocks',
    outputs: [{ internalType: 'bool', name: '', type: 'bool' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [
      { internalType: 'bytes32', name: 'role', type: 'bytes32' },
      { internalType: 'address', name: 'account', type: 'address' },
    ],
    name: 'renounceRole',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [
      { internalType: 'bytes32', name: 'role', type: 'bytes32' },
      { internalType: 'address', name: 'account', type: 'address' },
    ],
    name: 'revokeRole',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'bool', name: '_enabled', type: 'bool' }],
    name: 'setClaimStakeEnabled',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [
      {
        internalType: 'address',
        name: '_delegatorPoolImpl',
        type: 'address',
      },
    ],
    name: 'setDelegatorPoolImpl',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'address', name: '_l1Migrator', type: 'address' }],
    name: 'setL1Migrator',
    outputs: [],
    stateMutability: 'nonpayable',
    type: 'function',
  },
  {
    inputs: [{ internalType: 'bytes4', name: 'interfaceId', type: 'bytes4' }],
    name: 'supportsInterface',
    outputs: [{ internalType: 'bool', name: '', type: 'bool' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [],
    name: 'ticketBrokerAddr',
    outputs: [{ internalType: 'address', name: '', type: 'address' }],
    stateMutability: 'view',
    type: 'function',
  },
  {
    inputs: [],
    name: 'tokenAddr',
    outputs: [{ internalType: 'address', name: '', type: 'address' }],
    stateMutability: 'view',
    type: 'function',
  },
  { stateMutability: 'payable', type: 'receive' },
] as const;
